﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace timediff
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private struct HMS
        {
           public Int32 Hour;
           public Int32 Minute;
           public Int32 Second;
        }

        private Int64 Time_Diff()
        {
            HMS hms1 = new HMS();
            HMS hms2 = new HMS();
            String[] s1 = textBox1.Text.Split(':');
            String[] s2 = textBox2.Text.Split(':');
            hms1.Hour = Int32.Parse(s1[0]);
            hms1.Minute = Int32.Parse(s1[1]);
            hms1.Second = Int32.Parse(s1[2]);
            hms2.Hour = Int32.Parse(s2[0]);
            hms2.Minute = Int32.Parse(s2[1]);
            hms2.Second = Int32.Parse(s2[2]);
            Int64 Diff = new Int64();
            for (Int32 i = (dateTimePicker1.Value.Year + 1); i < dateTimePicker2.Value.Year; i++)
            {
                if (LeapYear(i))
                {
                    Diff += 366;
                }
                else
                {
                    Diff += 365;
                }
            }

            if (dateTimePicker1.Value.Year == dateTimePicker2.Value.Year)
            {
                if (LeapYear(dateTimePicker2.Value.Year))
                {
                    Diff -= 366;
                }
                else
                {
                    Diff -= 365;
                }
            }

            for (Int32 i = dateTimePicker1.Value.Month; i <= 12; i++)
            {
                if (i == 2)
                {
                    if (LeapYear(dateTimePicker1.Value.Year))
                    {
                        Diff += 29;
                    }
                    else
                    {
                        Diff += 28;
                    }
                }
                else if (i == 1 || i == 3 || i == 5 || i == 7 || i == 8 || i == 10 || i == 12)
                {
                    Diff += 31;
                }
                else
                {
                    Diff += 30;
                }
            }

            for (Int32 i = 1; i < dateTimePicker2.Value.Month; i++)
            {
                if (i == 2)
                {
                    if (LeapYear(dateTimePicker2.Value.Year))
                    {
                        Diff += 29;
                    }
                    else
                    {
                        Diff += 28;
                    }
                }
                else if (i == 1 || i == 3 || i == 5 || i == 7 || i == 8 || i == 10 || i == 12)
                {
                    Diff += 31;
                }
                else
                {
                    Diff += 30;
                }
            }

            return (Diff - (Int64)dateTimePicker1.Value.Day + (Int64)dateTimePicker2.Value.Day) * 86400 - (Int64)(hms1.Hour * 3600 + hms1.Minute * 60 + hms1.Second) + (Int64)(hms2.Hour * 3600 + hms2.Minute * 60 + hms2.Second);
        }

        private Boolean LeapYear(Int32 year)
        {
            if (year % 100 == 0)
            {
                if (year % 400 == 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if (year % 4 == 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        private void radioButton1_Click(object sender, EventArgs e)
        {
            Int64 Time = Time_Diff();
            label4.Text = (Time / 86400).ToString() + "天" + ((Time % 86400) / 3600).ToString() + "時" + (((Time % 86400) % 3600) / 60).ToString() + "分" + (((Time % 86400) % 3600) % 60).ToString() + "秒";
        }

        private void radioButton4_Click(object sender, EventArgs e)
        {
            label4.Text = "    " + Time_Diff().ToString() + "秒";
        }

        private void radioButton3_Click(object sender, EventArgs e)
        {
            Int64 Time = Time_Diff();
            label4.Text = "   " + (Time / 60).ToString() + "分" + (Time % 60).ToString() + "秒";
        }

        private void radioButton2_Click(object sender, EventArgs e)
        {
            Int64 Time = Time_Diff();
            label4.Text = "  " + (Time / 3600).ToString() + "時" + ((Time % 3600) / 60).ToString() + "分" + ((Time % 3600) % 60).ToString() + "秒";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = "00:00:00";
            textBox2.Text = "00:00:00";
        }
    }
}
